<?php


namespace Pushpro\Pushpro\Domain\Repository;


use TYPO3\CMS\Core\Database\ConnectionPool;
use TYPO3\CMS\Core\Utility\GeneralUtility;

trait PushproRepositoryTrait
{
    public $tokenTable = 'tx_pushpro_domain_model_pushprotoken';

    public function getRecord()
    {
        $connection = $this->localConnect();
        if($connection){
            $queryBuilder = $connection->createQueryBuilder();
            $query        = $queryBuilder
                ->select('*')
                ->from($this->tokenTable)
                ->where('pid = 0')
                ->where(
                    'deleted = 0'
                );

            $rows = $query->execute();

            return $rows;
        }
        return null;
    }

    public function countRecords(){
        $connection = $this->localConnect();
        if($connection){
            $queryBuilder = $connection->createQueryBuilder();
            $query        = $queryBuilder
                ->count('uid')
                ->from($this->tokenTable)
                ->where(
                    'deleted = 0'
                );

            $rows = $query->execute()->fetchColumn(0);

            return $rows;
        }
        return null;
    }

    public function getToken(){
        return $this->getRecord() ? $this->getRecord()->fetch()['token'] : '';
    }

    public function localConnect(){
        if($this->checkIfTableExists($this->tokenTable)){
            return GeneralUtility::makeInstance(ConnectionPool::class)
                                 ->getConnectionForTable($this->tokenTable);
        }
        return null;
    }

    protected function checkIfTableExists($table)
    {
        return GeneralUtility::makeInstance(ConnectionPool::class)
                             ->getConnectionForTable($table)
                             ->getSchemaManager()
                             ->tablesExist([$table]);
    }
}