<?php

namespace Pushpro\Pushpro\User;


use Pushpro\Pushpro\Domain\Repository\OuterPushproTokenRepository;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Extbase\Object\ObjectManager;

class SnippetGenerator
{

    public function generateInlineJsSnippet($params, $pageRenderer)
    {
        $token = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(\Pushpro\Pushpro\Domain\Repository\OuterPushproTokenRepository::class)->getToken();
        $apiCall = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(\Pushpro\Pushpro\Service\ApiCall::class, new\TYPO3\CMS\Core\Http\RequestFactory());
        $snippet = $apiCall->setApiKey($token)->snippet();

        if($snippet){
            $snippet->sw_path = 'typo3conf/ext/pushpro/Public/Javascript/Sw';
            $snippetEncoded = json_encode($snippet);
        }else{
            $snippetEncoded = '{}';
        }

        if(!strstr($_SERVER['REQUEST_URI'], '/typo3/')){
            $pageRenderer->addJsInlineCode('pushpro', " window.onload = function() {
               !function () {
	                window.__pushpro = $snippetEncoded
	                let pushProLib = document.createElement('script');
	                pushProLib.src = 'https://storage.googleapis.com/push-pro-java-scripts/pushpro-lib.js';
	                document.head.appendChild(pushProLib);}();
               }
              ");
        }
    }
}
